# coding: utf-8

"""
    College Basketball Data API

    This API is in limited Beta for Patreon subscribers. It may have bugs and is subject to changes. API keys can be acquired from the CollegeFootballData.com website.

    The version of the OpenAPI document: 1.20.0
    Contact: admin@collegefootballdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr
from cbbd.models.season_shooting_stats_attempts_breakdown import SeasonShootingStatsAttemptsBreakdown
from cbbd.models.season_shooting_stats_dunks import SeasonShootingStatsDunks
from cbbd.models.shot_type_breakdown import ShotTypeBreakdown

class SeasonShootingStats(BaseModel):
    """
    SeasonShootingStats
    """
    season: StrictInt = Field(...)
    team_id: StrictInt = Field(default=..., alias="teamId")
    team: StrictStr = Field(...)
    conference: Optional[StrictStr] = Field(...)
    tracked_shots: StrictInt = Field(default=..., alias="trackedShots")
    assisted_pct: Union[StrictFloat, StrictInt] = Field(default=..., alias="assistedPct")
    dunks: SeasonShootingStatsDunks = Field(...)
    layups: SeasonShootingStatsDunks = Field(...)
    tip_ins: ShotTypeBreakdown = Field(default=..., alias="tipIns")
    two_point_jumpers: SeasonShootingStatsDunks = Field(default=..., alias="twoPointJumpers")
    three_point_jumpers: SeasonShootingStatsDunks = Field(default=..., alias="threePointJumpers")
    attempts_breakdown: SeasonShootingStatsAttemptsBreakdown = Field(default=..., alias="attemptsBreakdown")
    __properties = ["season", "teamId", "team", "conference", "trackedShots", "assistedPct", "dunks", "layups", "tipIns", "twoPointJumpers", "threePointJumpers", "attemptsBreakdown"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SeasonShootingStats:
        """Create an instance of SeasonShootingStats from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of dunks
        if self.dunks:
            _dict['dunks'] = self.dunks.to_dict()
        # override the default output from pydantic by calling `to_dict()` of layups
        if self.layups:
            _dict['layups'] = self.layups.to_dict()
        # override the default output from pydantic by calling `to_dict()` of tip_ins
        if self.tip_ins:
            _dict['tipIns'] = self.tip_ins.to_dict()
        # override the default output from pydantic by calling `to_dict()` of two_point_jumpers
        if self.two_point_jumpers:
            _dict['twoPointJumpers'] = self.two_point_jumpers.to_dict()
        # override the default output from pydantic by calling `to_dict()` of three_point_jumpers
        if self.three_point_jumpers:
            _dict['threePointJumpers'] = self.three_point_jumpers.to_dict()
        # override the default output from pydantic by calling `to_dict()` of attempts_breakdown
        if self.attempts_breakdown:
            _dict['attemptsBreakdown'] = self.attempts_breakdown.to_dict()
        # set to None if conference (nullable) is None
        # and __fields_set__ contains the field
        if self.conference is None and "conference" in self.__fields_set__:
            _dict['conference'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SeasonShootingStats:
        """Create an instance of SeasonShootingStats from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SeasonShootingStats.parse_obj(obj)

        _obj = SeasonShootingStats.parse_obj({
            "season": obj.get("season"),
            "team_id": obj.get("teamId"),
            "team": obj.get("team"),
            "conference": obj.get("conference"),
            "tracked_shots": obj.get("trackedShots"),
            "assisted_pct": obj.get("assistedPct"),
            "dunks": SeasonShootingStatsDunks.from_dict(obj.get("dunks")) if obj.get("dunks") is not None else None,
            "layups": SeasonShootingStatsDunks.from_dict(obj.get("layups")) if obj.get("layups") is not None else None,
            "tip_ins": ShotTypeBreakdown.from_dict(obj.get("tipIns")) if obj.get("tipIns") is not None else None,
            "two_point_jumpers": SeasonShootingStatsDunks.from_dict(obj.get("twoPointJumpers")) if obj.get("twoPointJumpers") is not None else None,
            "three_point_jumpers": SeasonShootingStatsDunks.from_dict(obj.get("threePointJumpers")) if obj.get("threePointJumpers") is not None else None,
            "attempts_breakdown": SeasonShootingStatsAttemptsBreakdown.from_dict(obj.get("attemptsBreakdown")) if obj.get("attemptsBreakdown") is not None else None
        })
        return _obj


